package org.aspectj.runtime.internal;

import java.util.*;
import org.aspectj.runtime.*;
import org.aspectj.lang.*;

public class CFlowStack
{
    private java.util.Hashtable stacks;
    private java.lang.Thread cached_thread;
    private org.aspectj.runtime.internal.MyStack cached_stack;
    private int change_count;
    // private static final int COLLECT_AT;
    // private static final int MIN_COLLECT_AT;

    public CFlowStack()
    {
        super();

        stacks = new Hashtable();
        change_count = 0;
        return;
    }

    public synchronized org.aspectj.runtime.internal.MyStack getThreadStack()
    {
        int i0;
        java.util.Stack r2;
        java.util.Enumeration r3, r23;
        java.lang.Thread r4, r25;

        if (Thread.currentThread() != cached_thread)
        {
            cached_thread = Thread.currentThread();
            cached_stack = (MyStack) stacks.get(cached_thread);

            if (cached_stack == null)
            {
                cached_stack = new MyStack();
                stacks.put(cached_thread, cached_stack);
            }

            change_count = change_count + 1;
            i0 = Math.max(1, stacks.size());

            if (change_count > Math.max(100, 20000 / i0))
            {
                r2 = new Stack();
                r3 = stacks.keys();

                while (r3.hasMoreElements() != false)
                {
                    r4 = (Thread) r3.nextElement();

                    if (r4.isAlive() == false)
                    {
                        r2.push(r4);
                    }
                }

                r23 = r2.elements();

                while (r23.hasMoreElements() != false)
                {
                    r25 = (Thread) r23.nextElement();
                    stacks.remove(r25);
                }

                change_count = 0;
            }
        }

        return cached_stack;
    }

    public void push(java.lang.Object r1)
    {
        this.getThreadStack().push(r1);
        return;
    }

    public void pushInstance(java.lang.Object r1)
    {
        this.getThreadStack().push(new CFlow(r1));
        return;
    }

    public void push(java.lang.Object[] r1)
    {
        this.getThreadStack().push(new CFlowPlusState(r1));
        return;
    }

    public void pushCounter()
    {
        org.aspectj.runtime.internal.MyStack $r1;

        $r1 = this.getThreadStack();
        $r1.counter = $r1.counter + 1;
        return;
    }

    public void popCounter()
    {
        org.aspectj.runtime.internal.MyStack $r1;

        $r1 = this.getThreadStack();
        $r1.counter = $r1.counter - 1;
        return;
    }

    public void pop()
    {
        this.getThreadStack().pop();
        return;
    }

    public java.lang.Object peek()
    {
        org.aspectj.runtime.internal.MyStack r1;

        r1 = this.getThreadStack();

        if (r1.isEmpty() == false)
        {
            return r1.peek();
        }
        else
        {
            throw new NoAspectBoundException();
        }
    }

    public java.lang.Object get(int i0)
    {
        org.aspectj.runtime.CFlow r1;
        java.lang.Object $r2;

        r1 = this.peekCFlow();

        if (null != r1)
        {
            $r2 = r1.get(i0);
        }
        else
        {
            $r2 = null;
        }

        return $r2;
    }

    public java.lang.Object peekInstance()
    {
        org.aspectj.runtime.CFlow r1;

        r1 = this.peekCFlow();

        if (r1 == null)
        {
            throw new NoAspectBoundException();
        }
        else
        {
            return r1.getAspect();
        }
    }

    public org.aspectj.runtime.CFlow peekCFlow()
    {
        org.aspectj.runtime.internal.MyStack r1;

        r1 = this.getThreadStack();

        if (r1.isEmpty() == false)
        {
            return (CFlow) r1.peek();
        }
        else
        {
            return null;
        }
    }

    public org.aspectj.runtime.CFlow peekTopCFlow()
    {
        org.aspectj.runtime.internal.MyStack r1;

        r1 = this.getThreadStack();

        if (r1.isEmpty() == false)
        {
            return (CFlow) r1.elementAt(0);
        }
        else
        {
            return null;
        }
    }

    public boolean isValid()
    {
        boolean $z1;

        if (this.getThreadStack().isEmpty() != false)
        {
            $z1 = false;
        }
        else
        {
            $z1 = true;
        }

        return $z1;
    }

    public boolean isCounterValid()
    {
        boolean $z0;

        if (this.getThreadStack().counter <= 0)
        {
            $z0 = false;
        }
        else
        {
            $z0 = true;
        }

        return $z0;
    }
}
